from . import _magnetostaticField
from ngsolve import VectorH1
from . import _detailsOerstedField
from commics._tools.algebra import Curl


################################################################################


class OerstedField(_magnetostaticField._MagnetostaticField):


  _discreteSpace = VectorH1
  _decomposition = lambda h1, h2: h1 + h2
  _lfOperator = lambda phi: Curl(phi.Deriv())
  _label = "hc"

  _femInitializer = _detailsOerstedField.DetailsOerstedField
  _femStatic = None


#-----------------------------------------------------------------------------#


  def __init__(self, mesh, je_cf, solvetol, flag_je_stationary):
    self._flag_stationary = flag_je_stationary
    self._flag_alreadyComputed = False
    _magnetostaticField._MagnetostaticField.__init__(self, mesh, je_cf, solvetol)


#-----------------------------------------------------------------------------#


  def Compute(self, solvetol):
    if self._flag_alreadyComputed and self._flag_stationary:
      pass
    else:
      _magnetostaticField._MagnetostaticField.Compute(self, solvetol)
      self._flag_alreadyComputed = True


#-----------------------------------------------------------------------------#


  def UpdateFlags(self, flag_je_stationary):
    self._flag_stationary = flag_je_stationary
    self._flag_alreadyComputed = False


#-----------------------------------------------------------------------------#


################################################################################
