from netgen.meshing import Element2D

################################################################################

#------------------------------------------------------------------------------#

def AddMesh_TopFace(ngmesh, fd, p):
  for j in range(p.shape[0]-1):
    for k in range(p.shape[1]-1):
      ngmesh.Add(Element2D(fd, [p[j,k], p[j+1, k+1], p[j, k+1]]))
      ngmesh.Add(Element2D(fd, [p[j,k], p[j+1, k], p[j+1, k+1]]))

#------------------------------------------------------------------------------#

def AddMesh_BottomFace(ngmesh, fd, p):
  for j in range(p.shape[0]-1):
    for k in range(p.shape[1]-1):
      ngmesh.Add(Element2D(fd, [p[j,k], p[j, k+1], p[j+1, k+1]]))
      ngmesh.Add(Element2D(fd, [p[j,k], p[j+1, k+1], p[j+1, k]]))

#------------------------------------------------------------------------------#

def AddMesh_LeftFace(ngmesh, fd, p):
  for j in range(p.shape[0]-1):
    for k in range(p.shape[1]-1):
      ngmesh.Add(Element2D(fd, [p[j+1,k], p[j, k+1], p[j+1, k+1]]))
      ngmesh.Add(Element2D(fd, [p[j+1,k], p[j, k], p[j, k+1]]))

#------------------------------------------------------------------------------#

def AddMesh_RightFace(ngmesh, fd, p):
  for j in range(p.shape[0]-1):
    for k in range(p.shape[1]-1):
      ngmesh.Add(Element2D(fd, [p[j+1,k], p[j+1, k+1], p[j, k+1]]))
      ngmesh.Add(Element2D(fd, [p[j+1,k], p[j, k+1], p[j, k]]))

#------------------------------------------------------------------------------#

def AddMesh_FrontFace(ngmesh, fd, p): AddMesh_RightFace(ngmesh, fd, p)

#------------------------------------------------------------------------------#

def AddMesh_BackFace(ngmesh, fd, p): AddMesh_LeftFace(ngmesh, fd, p)

#------------------------------------------------------------------------------#

################################################################################
