

################################################################################


## plotData(t,x,y,z)
# plot the components x,y,z versus time t
def plotData(t,x,y,z):
  import matplotlib
  matplotlib.use("Agg")
  import matplotlib.pyplot as plt
  fig, ax = plt.subplots()
  
  ax.plot(t, x, label='<m_x>')
  ax.plot(t, y, label='<m_y>')
  ax.plot(t, z, label='<m_z>')
  
  plt.xlabel('Time')
  plt.ylabel('m')
  plt.title('Time evolution of <m>')
  plt.axis([t[0], t[t.size-1], -1, 1])
  
  legend = ax.legend()
  plt.show()


################################################################################


## compareResults(file1, file2)
# files are supposed to have 4 columns [t, mx, my, mz]
def compareResults(resultFile, referenceFile):
  import numpy as np
  A = np.loadtxt(resultFile, comments="#")
  B = np.loadtxt(referenceFile, comments="#")
  
  fig, axarr = plt.subplots(3, sharex=True)
  axarr[0].plot(A[:,0], A[:,1], 'r', B[:,0], B[:,1], 'k')
  axarr[1].plot(A[:,0], A[:,2], 'r', B[:,0], B[:,2], 'k')
  axarr[2].plot(A[:,0], A[:,3], 'r', B[:,0], B[:,3], 'k')
  
  axarr[0].set_title("<m_x>")
  axarr[1].set_title("<m_y>")
  axarr[2].set_title("<m_z>")
  
  plt.show()


################################################################################
