

################################################################################


def TimeToString(t):
  if t == 0.0:
    return "0.00 s".rjust(10)
  if abs(t) >= 1.0 or abs(t) < 1e-18:
    return ("%e" % t) + " s"

  timeScaler = {0: 's', 3: 'ms', 6: 'µs', 9: 'ns', 12: 'ps', 15: 'fs', 18: 'as'}

  exp = -int(("%e" % t)[-3:])

  rep = ((exp + 1) // 3) * 3

  p = 10 ** (rep)

  return (("%2.2f" % (t*p)) + " " + timeScaler[rep]).rjust(10)


################################################################################
