

################################################################################


def Mesh2VTK(mesh):
  header = "# vtk DataFile Version 3.0\n"
  header += "vtk output\n"
  header += "ASCII\n"
  header += "DATASET UNSTRUCTURED_GRID\n"
  
  tetra_nr = 10
  
  # points
  points = "POINTS " + str(mesh.nv) + " float\n"
  for j in range(1,mesh.nv+1,1):
    for k in range(mesh.dim):
      points += " " + str(mesh.ngmesh.Points()[j][k])
    points += "\n"
  
  # cells 
  cells = "CELLS " + str(mesh.ne) + " " + str((mesh.dim + 2)*mesh.ne) + "\n"
  for j in range(mesh.ne):
    cells += str(mesh.dim+1) +  " "
    for k in range(mesh.dim+1):
      cells += str(mesh.ngmesh.Elements3D()[j].vertices[k].nr-1) + " "
    cells += "\n"
  
  cell_types = "CELL_TYPES " + str(mesh.ne) + "\n"
  for j in range(mesh.ne):
    cell_types += str(tetra_nr) + " \n"
  
  return header + points + cells + cell_types


################################################################################


def Mag2VTK(mesh, m, label="m"):
  header =  "CELL_DATA " + str(mesh.ne) + "\n"
  header += "POINT_DATA " + str(mesh.nv) + "\n"
  header += "FIELD FieldData 1\n"
  header += label + " " + str(mesh.dim) + " " + str(mesh.nv) + " float\n"
  
  mag = ""
  for j in range(mesh.nv):
    for k in range(mesh.dim):
      mag += str(m.components[k].vec[j]) + " "
  mag += "\n"
  
  return header + mag


################################################################################
