from . import _preconditionerInterface

################################################################################


class MPSPreconditioner(_preconditionerInterface._PreconditionerInterface):


#------------------------------------------------------------------------------#

  
  def _SetUpPreconditioner(self):

    if(self.parameters.preconditionerType == "jacobi"):
      self._SetUpPreconditioner_Jacobi()
    elif(self.parameters.preconditionerType == None):
      self._SetUpPreconditioner_None()
    else:
      raise ValueError("preconditionerType = " \
      , self.parameters.preconditionerType, "not known")


#------------------------------------------------------------------------------#


  def _UpdatePreconditioner(self):
    if(self.parameters.preconditionerType == "jacobi"):
      self._UpdatePreconditioner_Jacobi()
    elif(self.parameters.preconditionerType == None):
      self._UpdatePreconditioner_None()
    else:
      raise ValueError("preconditionerType = ", self.parameters.preconditionerType \
        , "not known")


#------------------------------------------------------------------------------#

  
  def _SetUpPreconditioner_Jacobi(self):
    import scipy.sparse.linalg
    pjac = 1.0 / self._LHS_stat.diagonal()

    jacobi3D = lambda x: pjac * x
    self._preconditioner = scipy.sparse.linalg.LinearOperator( \
      (pjac.size, pjac.size), matvec=jacobi3D)


#------------------------------------------------------------------------------#

  
  def _SetUpPreconditioner_None(self):
    self._preconditioner = None


#------------------------------------------------------------------------------#


  def _UpdatePreconditioner_Jacobi(self):
    pass


#------------------------------------------------------------------------------#


  def _UpdatePreconditioner_None(self):
    pass


#------------------------------------------------------------------------------#


################################################################################
