from . import _interface

################################################################################


class ParameterInterface(_interface._Interface):
  

#------------------------------------------------------------------------------#


  def SetResultsFolder(self, foldername):
    self.output.foldername = foldername


#------------------------------------------------------------------------------#


  def SetParameter_A(self, value):
    self.parameters.A = value


#------------------------------------------------------------------------------#


  def SetParameter_Ms(self, value):
    self.parameters.Ms = value


#------------------------------------------------------------------------------#


  def SetParameter_K(self, value):
    self.parameters.K = value


#------------------------------------------------------------------------------#


  def SetParameter_D(self, value):
    self.parameters.D = value


#------------------------------------------------------------------------------#


  def SetParameter_alpha(self, value):
    self.parameters.alpha = value


#------------------------------------------------------------------------------#


  def SetParameter_alphaPreconditioner(self, value):
    self.parameters.alphaPreconditioner = value


#------------------------------------------------------------------------------#


  def SetParameter_T_start(self, value):
    self.parameters.T_start = value


#------------------------------------------------------------------------------#


  def SetParameter_T_end(self, value):
    self.parameters.T_end = value


#------------------------------------------------------------------------------#


  def GetParameter_T_start(self):
    return self.parameters.T_start


#------------------------------------------------------------------------------#


  def GetParameter_T_end(self):
    return self.parameters.T_end


#------------------------------------------------------------------------------#


  def SetParameter_TimeStepSize(self, value):
    self.parameters.timeStepSize = value


#------------------------------------------------------------------------------#


  def GetParameter_TimeStepSize(self):
    return self.parameters.timeStepSize


#------------------------------------------------------------------------------#


  def SetParameter_H_ext(self, value):
    self.parameters.H_ext = value


#------------------------------------------------------------------------------#


  def SetParameter_easy_axis(self, value):
    self.parameters.easy_axis = value


#------------------------------------------------------------------------------#


  def SetParameter_P(self, value):
    self.parameters.P = value


#------------------------------------------------------------------------------#


  def SetParameter_J(self, value):
    self.parameters.J = value


#------------------------------------------------------------------------------#


  def SetParameter_xi(self, value):
    self.parameters.xi = value


#------------------------------------------------------------------------------#


  def SetParameter_dmCoupling(self, value):
    self.parameters.dmCoupling = value


#------------------------------------------------------------------------------#


  def SetParameter_maxwellCoupling(self, value):
    if value != self.parameters.maxwellCoupling:
      self._maxwellCouplingChanged = True
    self.parameters.maxwellCoupling = value


#------------------------------------------------------------------------------#


  def SetParameter_spintronicsCoupling(self, value):
    self.parameters.spintronicsCoupling = value


#------------------------------------------------------------------------------#


  def SetParameter_Je(self, value):
    self.parameters.Je = value


#------------------------------------------------------------------------------#


  def SetParameter_FlagJeStationary(self, value):
    self.parameters.flag_Je_stationary = value


#------------------------------------------------------------------------------#


  def SetParameter_d(self, value):
    self.parameters.d = value


#------------------------------------------------------------------------------#


  def SetParameter_p(self, value):
    self.parameters.p = value


#------------------------------------------------------------------------------#


  def SetPreconditioner(self, value):
    self.parameters.preconditionerType = value


#------------------------------------------------------------------------------#


  def SetGuess(self, value):
    self.parameters.guessType = value


#------------------------------------------------------------------------------#


  def CountIterations(self, value=True):
    if value:
      self._callback = self._itCounter
    else:
      self._callback = None


#------------------------------------------------------------------------------#


  def CountFixedPointIterations(self, value=True):
    if value:
      self._fixedPointCallback = self._fixedPointItCounter
    else:
      self._fixedPointCallback = None


#------------------------------------------------------------------------------#


  def _RecordMagnetization(self, record, maxwell, every):
    self.output.video = record
    self.output.videoMaxwell = maxwell
    self._saveMagEvery = every


#------------------------------------------------------------------------------#


  def SetTOL(self, value):
    self.parameters.TOL = value


#------------------------------------------------------------------------------#


  def RecordExternalFieldAt(self, value):
    self.parameters.externalFieldRecordingPoint = value


#------------------------------------------------------------------------------#


  def GetParameter_Scaling(self):
    return self._geometry.scaling


#------------------------------------------------------------------------------#


  def GetParameter_Ms(self):
    return self.parameters.Ms


#------------------------------------------------------------------------------#


################################################################################
