### collection of Magnetization linear forms ###


################################################################################


class LinearForms_Magnetization:
  

#------------------------------------------------------------------------------#


  def _LinearTerms_pi(self):
    return self._UniaxialAnisotropyTerm() + self._StrayFieldTerm() \
      + self._DzyaloshinskiiMoriyaTerm()


#------------------------------------------------------------------------------#


  def _LinearTerms_pi_Explicit_RHS(self):
    return self._UniaxialAnisotropyTerm() + self._StrayFieldTerm() \
      + self._DzyaloshinskiiMoriyaTerm_Explicit_RHS()


#------------------------------------------------------------------------------#


  def _LinearTerms_pi_Implicit_RHS(self):
    return self._DzyaloshinskiiMoriyaTerm_Implicit_RHS()


#------------------------------------------------------------------------------#


  def _UniaxialAnisotropyTerm(self):
    return -self._C_ani * self._UniaxialAnisotropy(self._Mag.m)


#------------------------------------------------------------------------------#


  def _StrayFieldTerm(self):
    return self._Stray(self._Mag)


#------------------------------------------------------------------------------#


  def _DzyaloshinskiiMoriyaTerm(self):
    return -0.5 * self._C_dm \
      * self._DzyaloshinskiiMoriya(self._Mag.m, self._Mag.Dm)


#------------------------------------------------------------------------------#


  def _DzyaloshinskiiMoriyaTerm_Explicit_RHS(self):
    if self.parameters.dmImplicitTreatment:
      return self._ZeroCF()
    else:
      return -0.5 * self._C_dm \
        * self._DzyaloshinskiiMoriya(self._Mag.m, self._Mag.Dm)


#------------------------------------------------------------------------------#


  def _DzyaloshinskiiMoriyaTerm_Implicit_RHS(self):
    if self.parameters.dmImplicitTreatment:
      return -0.5 * self._C_dm \
        * self._DzyaloshinskiiMoriya(self._Mag.m, self._Mag.Dm)
    else:
      return self._ZeroCF()


#------------------------------------------------------------------------------#


  def _NonLinearTerms_Pi(self):
    return self._SpintronicsTerm()


#------------------------------------------------------------------------------#


  def _SpintronicsTerm(self):
    return self._C_st * self._Spintronics(self._Mag.m, self._Mag.Dm)


#------------------------------------------------------------------------------#


  def _NowDerivNonLinearTerms(self):
    return self._NowDerivSpintronicsTerm()


#------------------------------------------------------------------------------#


  def _NowDerivSpintronicsTerm(self):
    return self._C_st * self._NowDerivSpintronics()


#------------------------------------------------------------------------------#


  def _NowDerivSpintronics(self):
    return self._DerivSpintronics(self._Mag.m, self._Mag.m \
      , self._Mag.Dm, self._Mag.Dm)


#------------------------------------------------------------------------------#


  def _RhsMass(self):
    return self._LfMass(self._Mag.m)


#------------------------------------------------------------------------------#


################################################################################
