###  KW1+EE ###
from . import kw1


################################################################################


class KW1EE(kw1.KW1):
  # description of KW1EE


#------------------------------------------------------------------------------#


  def _UpdateGuess(self):
    if(self.parameters.guessType == "old"):
      self._UpdateGuess_Old()
    elif(self.parameters.guessType == None):
      self._UpdateGuess_None()
    else:
      raise ValueError("guessType = ", self.parameters.guessType, "not known")


#------------------------------------------------------------------------------#


  def _UpdateGuess_Old(self):
    self._guess = self._Mag.v.gf.vec.FV().NumPy()


#------------------------------------------------------------------------------#


  def _UpdateGuess_None(self):
    self._guess = None


#------------------------------------------------------------------------------#


  def _SetUpSystems(self):

    kw1.KW1._SetUpSystems(self)

    self._f_iter_parts = None


#------------------------------------------------------------------------------#


  def _StepPrepareWithoutTaskManager(self):
    self._ComputeSystemFromParts()


#------------------------------------------------------------------------------#


  def _ComputeSystemFromParts(self):
    self._Compute_LHS_instat()
    self._LHS = self._LHS_stat + self._LHS_instat

    self._Compute_RHS()


#------------------------------------------------------------------------------#

  
  def _Compute_RHS(self):
    self._RHS = self._Sh_MhInv(self._f_fix_parts.vec.FV().NumPy())


#------------------------------------------------------------------------------#


  def _Compute_v(self):
    import scipy.sparse.linalg

    self._Mag.v.gf.vec.FV().NumPy()[:], succ = scipy.sparse.linalg.gmres( \
      self._LHS, self._RHS \
      , x0=self._guess, tol=self._solvetol, maxiter=4000 \
      , M=self._preconditioner, callback=self._callback)

    self._UpdateGuess()
    

#------------------------------------------------------------------------------#


  def _DerivLinearTerms_pi(self):
    # not necessary 
    return self._ZeroCF()


#------------------------------------------------------------------------------#


################################################################################
