### projection free TPS 1 ###
from . import tps1


################################################################################


class TPS1PF(tps1.TPS1):
  '''
  same as TPS1, but omit projection
  '''


#------------------------------------------------------------------------------#

  
  def GetReady(self):
    from . import _tpsx

    self._solvetol = self.parameters.TOL
    self._theta = self.parameters.theta

    _tpsx.TPSX.GetReady(self)
  

#------------------------------------------------------------------------------#


  def _StepUpdate(self):
    self._Mag.m.vec.data += self._k * self._Mag.v.gf.vec


#------------------------------------------------------------------------------#


  def ProjectMagnetization(self):
    self._Mag.Project()


#------------------------------------------------------------------------------#


  def _H_proj(self, x, y, z):
    from scipy import sqrt
    from . import _tpsx
        
    tmp = sqrt(x*x + y*y + z*z)

    return _tpsx.TPSX._H_proj(self, x/tmp, y/tmp, z/tmp)
  
  
#------------------------------------------------------------------------------#


  def _R_proj(self, x, y, z):
    from scipy import sqrt
    from . import _tpsx
        
    tmp = sqrt(x*x + y*y + z*z)

    return _tpsx.TPSX._R_proj(self, x/tmp, y/tmp, z/tmp)
  
  
#------------------------------------------------------------------------------#


  def _S_proj(self, x, y, z):
    from scipy import sqrt
    from . import _tpsx
        
    tmp = sqrt(x*x + y*y + z*z)

    return _tpsx.TPSX._S_proj(self, x/tmp, y/tmp, z/tmp)
  
  
#------------------------------------------------------------------------------#


  @staticmethod
  def _IsMagProjected():
    return False


#------------------------------------------------------------------------------#


################################################################################
