from commics import *
from commics.addons import ConvergenceOrderWrapper

h = 0.3

geo = Geometry(geometry=UnitCube(), meshSize=h, scaling=1.0)
par = Parameters(A=5.0, Ms=1.0, K=0.0, gamma0=1.0, mu0=1.0, alpha=0.5 \
  , timeStepSize=1.0e-04, TOL=1e-13, T_start=0.0, T_end=5.0) 

from ngsolve import x
par.m0 = (1.0, 0.0, 0.0)
par.H_ext = (-2.0, -0.5, 0.0)

wrapper = ConvergenceOrderWrapper(referenceScheme=TPS2AB, otherScheme=TPS1, nrSimulations=5, geometry=geo, parameters=par, numthreads=4)

wrapper.SetResultsFolder("OrderResult")

# do
wrapper.GetReady()
wrapper.Do()
