from commics import *

geo = Geometry(geometry=Cuboid(500, 125, 3), meshSize=5.0, scaling=1e-09)
par = Parameters(A=1.3e-11, Ms=8.0e+05, K=0.0, gamma0=2.211e+05, alpha=1.0 \
  , T_start=0.0e-09, T_end=1.0e-09, timeStepSize=0.5e-12)

par.m0 = (1.0, 0.0, 0.0)

from math import sqrt
field = lambda t, x, y, z: (par.T_end - t) / (par.T_end - par.T_start) * 30.0e-03 / par.mu0 / sqrt(3.0)
par.H_ext = (field, field, field)


sp4 = Integrator(scheme=TPS2AB, geometry=geo, parameters=par, numthreads=4)
sp4.SetResultsFolder("SP4sStateResult")

sp4.Integrate()

sp4.Integrate(duration=1.0e-09, relax=True)
sp4.SaveMesh("sp4mesh")
sp4.SaveMagnetization("sp4sState")
